use feature ':5.10';

my $out_fname = $ARGV[0];
my $in_fname = $out_fname . ".orig";

rename $out_fname, $in_fname;

say "Fixing $in_fname ...";

open IN_FILE, '<', $in_fname or die "I couldn't read $in_fname!";
open OUT_FILE, '>', $out_fname or die "I couldn't create $out_fname!";

my @lines = <IN_FILE>;

my $file    = 0;
my $track   = 0;
my $err_pos = -1;

for($i = 0; $i < @lines; $i++) {
	unless ($lines[$i] =~ /INDEX 00/) {
		$file++ if $lines[$i] =~ /FILE/;
		$track++ if $lines[$i] =~ /TRACK/;
		if ($file < $track) {
			#say "error in line $i";
			for($e = $i+1; $e < @lines; $e++) {
				if ( $lines[$e] =~ /FILE/ ) {
					print OUT_FILE  $lines[$e] if $lines[$e] =~ /FILE/;
					delete $lines[$e];
					$file++;
					last;
				}
			}
		}
		print OUT_FILE  $lines[$i];
	}
}
close OUT_FILE;
close IN_FILE;

say "Done."
